<ng-container *ngIf="projects">
  <!--Account-->
  <app-options
    *ngIf="uiAccounts"
    title="Account"
    description="Account is identified by primary stakeholder, choose &#34;Leobit&#34; if not sure"
    [items]="uiAccounts"
    textField="name"
    [(selectedItem)]="uiSelectedAccount"
    (selectedItemChange)="onAccountChange($event)"
  >
  </app-options>

  <!--Project-->
  <app-options
    *ngIf="uiProjects"
    title="Project"
    description="Project is identified by primary stakeholder, choose &#34;Leobit: Internal&#34; if not sure"
    [items]="uiProjects"
    textField="name"
    [(selectedItem)]="selectedProject"
    (selectedItemChange)="selectedProjectChange.emit($event)"
  >
  </app-options>
</ng-container>

<div *ngIf="!isAllowedDate" class="form-group form-row">
  <label class="col-form-label offset-3 text-danger">
    This date is out of reporting range for this project
  </label>
</div>

<!--Date-->
<div *ngIf="batchReportingAllowed" class="form-group form-row">
  <label class="col-form-label offset-3 text-muted">
    For this project, you can report multiple dates simultaneously. All official holidays will be automatically excluded from the selected date range.
  </label>
</div>
<div *ngIf="batchReportingAllowed" class="form-group form-row">
  <label class="offset-1 col-10  offset-md-0 col-md-3 text-md-right"
    >Report multiple dates</label
  >
  <div class="offset-1 col-10 offset-md-0 col-md-6">
    <p-inputSwitch
      [(ngModel)]="reportMultipleDates"
      (ngModelChange)="onReportMultipleDatesChange()"
    ></p-inputSwitch>
  </div>
</div>
<div class="form-group form-row">
  <label
    class="col-form-label offset-1 offset-md-0 col-md-3 text-md-right"
    >Reporting Date</label
  >
  <div class="offset-1  offset-md-0 col-md-2">
    <p-calendar
      [ngModel]="batchReportingAllowed && reportMultipleDates ? dateRange : date"
      (ngModelChange)="batchReportingAllowed && reportMultipleDates ? dateRangeChange.emit($event) : dateChange.emit($event)"
      [readonlyInput]="true"
      [minDate]="uiFirstAllowedDate"
      [maxDate]="uiLastAllowedDate"
      [disabledDates]="uiDisabledDates"
      [locale]="globals.calendarLocale"
      [style]="{ width: '100%' }"
      [inputStyle]="{ width: '100%' }"
      [selectionMode]="batchReportingAllowed && reportMultipleDates ? 'range' : 'single'"
      [disabled]="isDisableDatePicker"
      [firstDayOfWeek]="1"
      appendTo="body"
    ></p-calendar>
  </div>
  <div *ngIf="!isDisableReOpenProjectReporting && !isOperational" class="offset-1 offset-md-0">
    <p-button
      label="Cannot report dates you need?"
      [link]="true"
      title="Request to temporarily open project reporting for specific dates"
      (click)="onReopenProjectReportingClick()"
    ></p-button>
  </div>
</div>

<!--Hours-->
<div class="form-group form-row">
  <label
    class="col-form-label offset-1  offset-md-0 col-md-3 text-md-right"
    >Internal hours</label
  >
  <div class="offset-1 offset-md-0 col-md-2">
    <p-dropdown
      [options]="uiInternalHours"
      [ngModel]="internalHours"
      (ngModelChange)="internalHoursChange.emit($event)"
      [style]="{ width: '100%' }"
    ></p-dropdown>
  </div>
  <label
    class="col-form-label  offset-1  offset-md-0 col-md-2 text-md-right"
    >External hours</label
  >
  <div class="offset-1 offset-md-0 col-md-2">
    <p-dropdown
      [options]="uiExternalHours"
      [ngModel]="externalHours"
      (ngModelChange)="externalHoursChange.emit($event)"
      [style]="{ width: '100%' }"
      [disabled]="!isExternal"
    ></p-dropdown>
  </div>
</div>

<!--Start time-->
<div *ngIf="isOperational && !isFullDay" class="form-group form-row">
  <label
    class="col-form-label offset-1 offset-md-0 col-md-3 text-md-right"
    >Start time</label
  >
  <div class="offset-1 offset-md-0 col-md-2">
    <p-dropdown
      #dropDown
      class="startTime"
      [options]="uiStartTime"
      [ngModel]="startTime"
      (ngModelChange)="startTimeChange.emit($event)"
      (focusout)="hourMask($event, '10:00')"
      (onFocus)="dropDown.show()"
      [editable]="true"
      [style]="{ width: '100%' }"
    ></p-dropdown>
  </div>
</div>

<!--Description-->
<div class="form-group form-row">
  <label class="offset-1 offset-md-0 col-md-3 text-md-right"
    >Description</label
  >
  <div class="offset-1 offset-md-0 col-md-6">
    <textarea
      [ngModel]="description"
      (ngModelChange)="descriptionChange.emit($event)"
      pInputTextarea
      required
      #descriptionArea="ngModel"
      [rows]="3"
      style="width: 100%"
      [autoResize]="autoResize"
    ></textarea>
  </div>
</div>

<!--Send copy-->
<ng-container *ngIf="sendMeCopyOfResponse != undefined">
  <div class="form-group form-row">
    <label class="offset-1  offset-md-0 col-md-3 text-md-right"
      >Send me a copy of my response</label
    >
    <div class="offset-1 offset-md-0 col-md-6">
      <p-inputSwitch
        [ngModel]="sendMeCopyOfResponse"
        (ngModelChange)="sendMeCopyOfResponseChange.emit($event)"
      ></p-inputSwitch>
    </div>
  </div>
</ng-container>

<div class="form-group form-row">
  <div class="offset-1 offset-md-3 col-md-2">
    <button
      pButton
      type="button"
      [label]="submitButtonLabel"
      (click)="submitClicked()"
      [disabled]="!isAllowedDate || !descriptionArea.valid || !startTime"
    ></button>
  </div>
</div>

<p-confirmDialog
  header="Confirmation"
  key="holidayConfirm"
  [closable]="false"
  icon="pi pi-exclamation-triangle"
></p-confirmDialog>

<p-dialog
  #dialog
  header="Reopen project reporting"
  [(visible)]="showReopenProjectReportingDialog"
  [responsive]="true"
  [resizable]="false"
  [focusOnShow]="false"
  showEffect="fade"
  (onHide)="hideDialog()"
  [modal]="true"
  [style]="{ width: appendInnerDialogToBody ? '530px' : '35%' }"
  [appendTo]="appendInnerDialogToBody ? 'body' : false"
>
  <div class="mx-2 my-3 text-muted">
    <p>
      If you forgot to report in time, and window is already closed, you can make a request to PMs to temporarily re-open the reporting window.
    </p>
    <p>
      By clicking "Request", all PMs of this project will receive a Slack notification.
      If any of them approves your request, the reporting will temporarily be re-opened, and you will receive a Slack notification.
    </p>
  </div>
  <hr class="mb-4 text-success">
  <div class="form-group form-row">
    <label class="col-form-label offset-1 offset-md-0 col-sm-3 col-md-4 text-md-right">Project</label>
    <div class="col-form-label font-weight-bold offset-1 offset-md-0 col-md-6">
      {{ selectedProject.account.name }} - {{ selectedProject.name }}
    </div>
  </div>
  <div class="form-group form-row">
    <label class="col-form-label offset-1 offset-md-0 col-sm-3 col-md-4 text-md-right">
      Select Date Range
    </label>
    <div class="offset-1 offset-md-0 col-md-6">
      <p-calendar
        appendTo="body"
        [(ngModel)]="reOpenDateRange"
        (ngModelChange)="onReOpenDateRangeChange()"
        [readonlyInput]="true"
        [selectionMode]="'range'"
        [locale]="globals.calendarLocale"
        [style]="{ width: '100%' }"
        [inputStyle]="{ width: '50%' }"
        [minDate]="minReopenReportingDate"
        [maxDate]="maxReopenReportingDate"
        [ngModelOptions]="{ standalone: true }"
        [firstDayOfWeek]="1"
        [defaultDate]="maxReopenReportingDate"
        (onClose)="onReopenDateRangeClosed()"
      ></p-calendar>
      <div *ngIf="reOpenDateRange && reOpenDateRange[1]" class="offset-1 offset-md-0 text-danger">
        <ng-container *ngIf="isReOpenDateRangeFullyAvailable || isReOpenDateRangeFullyConsistsOfHolidays">
          <ng-container *ngIf="isReOpenDateRangeFullyAvailable; else nonWorkingDaysOnly">
            The requested reporting range is already fully available
          </ng-container>
          <ng-template #nonWorkingDaysOnly>
            The requested reporting range fully consists of weekends and/or holidays
          </ng-template>
        </ng-container>
      </div>
    </div>
  </div>
  <div class="warning m-3" *ngIf="isReopenDateRangeSelected">
    <i class="fa fa-info-circle"></i>
    <span class="pl-2">Notification will be sent to {{ reopenReportAuthorityUsers | join }}</span>
  </div>
  <div class="form-group form-row">
    <div class="offset-2 offset-md-4 col-sm-3 col-md-4">
      <button
        pButton
        type="button"
        label="Request"
        [disabled] = "!reOpenDateRange || isReOpenDateRangeFullyAvailable || isReOpenDateRangeFullyConsistsOfHolidays"
        (click)="submitReOpenProjectReporting()"
      ></button>
    </div>
  </div>
</p-dialog>
